
/* writer.h */

#ifndef __PROG_WRITER_H__
#define __PROG_WRITER_H__

#include "std.h"
#include "memstream.h"

USE_NAMESPACE
// OPEN_NAMESPACE

class Writer
{
   public:
      void send (string s);
      void sendeol ();
      void sendln (string s);

      void sendLocation (int i) { }
      void sendStartNote (string s) { }
      void sendStopNote (string s) { }

      void style_space ();
      void style_no_space ();
      void style_new_line ();
      void style_empty_line ();
      void style_no_empty_line ();
      void style_indent ();
      void style_unindent ();

   /* ------------------------------------------------------------------- */

   private:
      string input_file_name;
      string output_file_name;
      MemStream * print_stream;

      int indentation;

      bool space;      // true => add space
      bool start_line; // true => beginning of empty line

      bool add_empty_line; // style recomendation - after current line add one empty line
      bool ignore_empty_line; // ignore add_empty_line variable

   public:
      bool skip_spaces;

   private:
      void print_cond_eol ();

   /* ------------------------------------------------------------------- */

   public:
      void set_input_name (const string file_name);
      string get_input_name ();

      // output to file
      void print_open (const string file_name);
      void print_close (); // check if same file already exists

      // output to string
      void print_open_string ();
      string print_close_string ();

      void print (const string s);
      void printeol ();
      void println (const string s);

      void indent ();
      void unindent ();

   public:
      Writer ();
};

// CLOSE_NAMESPACE

#endif /* __PROG_WRITER_H__ */
