unit idedemo;

interface

uses // simform  {type tsimwindow},
     // preview  {var  previewform},
     idefact  {type tlinkage},
     idetree  {type telement},
     idedesc  {type tbasicdesc},
     iderun   {func findcontext},
     simcls   {type tsimwindow},
     simctl   {type tsimwindow_element};

procedure demo (top: telement);
{ create preview of a window }

implementation

(********************************** demo **********************************)

procedure createviewbranch (elem: telement);
{ create products  }
var  sub: telement;
     rel: tlinkage;
     loc: telement;
begin
     { create product }
     assert (elem <> nil);
     elem.product := elem.createproduct;
     assert (elem.product <> nil);

     { subitems }
     sub := elem.firstelem;
     while sub <> nil do begin

        { create subitem }
        createviewbranch (sub);

        { link tree }
        if (elem.product <> nil) and (sub.product <> nil) then begin
           findcontext (elem, sub, loc, rel);
           if rel <> nil then
              rel.insertlast (loc.product, sub.product);
        end;

        sub := sub.nextelem;
     end;
end;

{--------------------------------------------------------------------------}

procedure setupviewbranch (elem: telement);
{ store parameter values }
var  sub: telement;
     param: tparam;
begin
     if elem.product <> nil then begin
        param := elem.firstparam;
        while param <> nil do begin
           param.store (elem.product);
           param := param.nextparam;
        end;
     end;

     { setup subitems }
     sub := elem.firstelem;
     while sub <> nil do begin
        setupviewbranch (sub);
        sub := sub.nextelem;
     end;
end;

{--------------------------------------------------------------------------}

procedure demo (top: telement);
var  win: tsimwindow;
begin
     while (top <> nil) and not (top is tsimwindow_element) do
        top := top.upperelem;

     if top <> nil then begin

        createviewbranch (top);
        setupviewbranch (top);

        if top.product is tsimwindow then begin
           win := top.product as tsimwindow;
           win.show;
        end;
     end;
end;

end.
