
import java.util.Vector;

class AltNode extends SourceNode
{
   public BlockNode above; // upper block
   public int index; // index within block, from 1
   public int nonterm_count; // number of nonterminals
   public int block_count; // number of blocks

   public boolean alt_ready; // result variable is ready (only for first pass)

   public boolean loop; // used <add> item
   public boolean braces; // block of code with, finally write right brace

   public RuleNode selection_rule; // subrule in selection block

   public boolean item_redudant; // current item is not used for list output
   public boolean next_redudant; // next item is not used for list output

   public boolean silent; // alternative with silent option
   public boolean directed; // alternative with syntactic or semantic predicate

   public AltNode next_alt;
   public SourceNode first_item;
   public SourceNode last_item;

   /* list */

   public void insertItem (SourceNode item)
   {
      if (first_item == null)
         first_item = item;
      else
         last_item.next_item = item;

      last_item = item;
      item.next_item = null;
   }

   /* conditions */

   public Vector ordKeys = new Vector ();

   public void addOrdKey (String name, String value)
   {
      DictItem2 item = new DictItem2 ();
      item.ident = name;
      item.value = value;
      ordKeys.add (item);
   }

   public Vector incKeys = new Vector ();

   public void addIncKey (String name)
   {
      incKeys.add (name);
   }

   public Vector refKeys = new Vector ();

   public void addRefKey (String name)
   {
      refKeys.add (name);
   }

   public Vector strKeys = new Vector ();

   public void addStrKey (String name)
   {
      strKeys.add (name);
   }

}
