
class GramSet extends Common
{
    public boolean    epsilon; // true => empty sequence is member of this set
    public int        count;
    public boolean [] table;

    public void unite (GramSet other)
    {
       if (other.epsilon)
          epsilon = true;

        for (int i = 0; i < count; i++)
           if (other.table [i])
              table [i] = true;
    }

    public void concatenate_symbol (int inx)
    {
       if (epsilon)
       {
          epsilon = false;

          // assert (inx <= count);
          table [inx] = true;
       }
    }

    public void concatenate (GramSet other)
    {
       if (epsilon)
       {
          epsilon = other.epsilon;

          for (int i = 0; i < count; i++)
             if (other.table [i])
                table [i] = true;
       }
    }

    public String compatible (GramSet other)
                               // TGramEnv env)
    {
       String note = ""; // empty string => ok

       for (int i = 0; i < count; i++)
          if (table [i] && other.table [i])
          {
             if (! empty (note))
                note += ", ";

             GramSymbol sym = info.getSymbol (i);
             note += sym.ident;
          }

       if (epsilon && other.epsilon)
       {
          if (! empty (note))
             note += ", ";

          note += "epsilon";
       }

       return note;
    }

    public int item_count ()
    {
       int result = 0;

       for (int i = 0; i < count; i++)
          if (table [i])
             result ++;

       return result;
    }

    public void allocate (int p_count)
    {
       epsilon = true;
       count = p_count;
       table = new boolean [count];

       for (int i = 0; i < count; i++)
          table [i] = false;
    }
}
