
import antlr.Token;
import antlr.ASTFactory;
import antlr.collections.AST;

class NodeFactory extends ASTFactory implements EG2TokenTypes
{

    public AST create (int type, String txt)
    {
        SourceNode p = null;

        if (type == RULE_DEF)
           p = new RuleNode ();

        else if (type == BLOCK_DEF)
           p = new BlockNode ();

        else if (type == ALTERNATIVE_DEF)
           p = new AltNode ();

        else if (type == TERMINAL_DEF)
           p = new TerminalNode ();

        else if (type == NONTERMINAL_DEF)
           p = new NontermNode ();

        else if (type == SEMANTIC_PREDICATE_DEF)
           p = new SemanticNode ();

        else if (type == SET_DEF)
           p = new SetOptionNode ();

        else if (type == INC_DEF)
           p = new IncOptionNode ();

        else if (type == EXECUTE_DEF)
           p = new ExecuteOptionNode ();

        else if (type == INVOKE_DEF)
           p = new InvokeOptionNode ();

        else if (type == PRIMITIVE_ITEM_DEF)
           p = new PrimitiveNode ();

        else if (type == BINARY_ITEM_DEF)
           p = new BinaryNode ();

        else if (type == ENUM_DEF ||
                 type == STRUCT_DEF ||
                 type == OPTION_DEF ||
                 type == EXTENSION_DEF )
           p = new SourceNode (); // only for line number (rememberPosition)

        if (p != null)
           p.line_number = Common.getLineNumber ();

        AST t = p;
        if (t==null) t = create ();
        t.initialize (type, txt);

        return t;
    }

}
