
import java.util.Enumeration;
import java.util.Vector;
import java.util.TreeMap;

class SymbolTable extends Common
{
  private TreeMap ident_tree = new TreeMap ();
  private TreeMap text_tree = new TreeMap ();
  private TreeMap num_tree = new TreeMap ();
  private Vector  list = new Vector ();
  private int     symbol_count = 0;

  public Enumeration elements ()
  {
    return list.elements ();
  }

  /*
  public int size ()
  {
    return ident_tree.size ();
  }

  public boolean empty ()
  {
    return ident_tree.isEmpty ();
  }
  */

  public boolean containsIdent (String ident)
  {
    return ident_tree.containsKey (ident);
  }

  public GramSymbol searchIdent (String ident)
  {
    return (GramSymbol) ident_tree.get (ident);
  }

  public boolean containsText (String text)
  {
     return text_tree.containsKey (text);
  }

  public GramSymbol searchText (String text)
  {
    return (GramSymbol) text_tree.get (text);
  }

  public GramSymbol searchIndex (int inx)
  {
    return (GramSymbol) num_tree.get (new Integer (inx));
  }

  public int getSymbolCount () { return symbol_count; }

  public void store (GramSymbol item)
  {
    if (item == null)
       err ("Null item");

    if (empty (item.ident))
       err ("Empty name");

    if (containsIdent (item.ident))
       err ("Symbol already defined: " + item.ident);

    if (containsText (item.text))
       err ("Symbol with same text representation already defined: " + item.text);

    item.index = symbol_count;
    symbol_count ++;

    ident_tree.put (item.ident, item);
    text_tree.put (item.text, item);
    num_tree.put (new Integer (item.index), item);
    list.add (item);
  }

}
