
class Test extends Tool
{
  // private int indent;

  private void send (String s)
  {
     // for (int i = 0; i < indent; i++) print ("  ");
     println (s);
  }

  /* grammar */

  public void openStruct(String type_name)
  {
     super.openStruct (type_name);
     send ("Struct " + type_name);
     indent ++;
  }

  public void closeStruct ()
  {
     super.closeStruct ();

     indent --;
     send ("End of struct");
  }

  public void structField (String name, String type, boolean pointer)
  {
     super.structField (name, type, pointer);
     send ("field " + name + " : " + ( pointer ? " * " : "" ) + type);
  }

  public void structSequence (String name, String type)
  {
     super.structSequence (name, type);
     send ("sequence " + name + " : " + type);
  }

  public void addSuper (String type_name,
                        String super_name)
  {
     super.addSuper (type_name, super_name);
     send ("type name = " + type_name);
     indent ++;
     send ("super type = " + super_name);
     indent --;
  }

  public void addTag (String name, String value)
  {
     super.addTag (name, value);
     indent ++;
     send ("tag " + name + " = " + value);
     indent --;
  }

  public void addCustom (String key)
  {
     super.addCustom (key);
     indent ++;
     send ("custom " + key);
     indent --;
  }

  public void addStore (String name, String type_name)
  {
     super.addStore (name, type_name);
     send ("Store " + name + " : " + type_name);
  }

  public void openEnum (String name)
  {
     super.openEnum (name);
     send ("Enum " + name);
     indent ++;
  }

  public void closeEnum ()
  {
     super.closeEnum ();


     indent --;
     send ("End of enum");
  }

  public void enumItem (String name)
  {
     super.enumItem (name);
     send ("item " + name);
  }

  public void literal (String name, String value)
  {
     super.literal (name, value);
     send ("literal " + name + " = " + value);
  }

  public void externalToken (String name)
  {
     super.externalToken (name);
     send ("externalToken " + name);
  }

  public void option (String name, String value)
  {
     super.option (name, value);
     send ("option " + name + " = " + value);
  }

  public void grammarOption (String name, String value)
  {
     super.grammarOption (name, value);
     send ("grammar_option " + name + " = " + value);
  }

  public void lexerOption (String name, String value)
  {
     super.lexerOption (name, value);
     send ("lexer_option " + name + " = " + value);
  }

  public void parserOption (String name, String value)
  {
     super.parserOption (name, value);
     send ("parser_option " + name + " = " + value);
  }

  public void extension (String name, String value)
  {
     super.extension (name, value);
     send ("extension " + name + " = " + value);
  }

  public void publicOption ()
  {
     super.publicOption ();
     send ("Public");
  }

  public void privateOption ()
  {
     super.privateOption ();
     send ("Private");
  }

  public void openRule (String name)
  {
     super.openRule (name);
     send ("Rule " + name);
     indent ++;
  }

  public void ruleParam (int mode,
                         String type_name)
  {
     super.ruleParam (mode, type_name);
     send ("Param " + type_name);
  }

  public void closeRule ()
  {
     super.closeRule ();
     indent --;
     send ("End of rule");
  }

  public void openBinary ()
  {
     super.openBinary ();
     send ("Binary");
     indent ++;
  }

  public void binaryBranch (String branch)
  {
     super.binaryBranch (branch);
     send ("branch " + branch);
     indent ++;
  }

  public void binaryItem (String key, String selector_value,
                          String middle_branch, String middle_key)
  {
     super.binaryItem (key, selector_value, middle_branch, middle_key);
     send ("item " + key + " " + selector_value);
  }

  public void closeBinary ()
  {
     super.closeBinary ();
     indent --;
  }

  public void unary (String key, String selector_value, String branch)
  {
     super.unary (key, selector_value, branch);
     send ("Unary " + key + " " + selector_value + " " + branch);
  }

  public void openPrimitive ()
  {
     super.openPrimitive ();
     send ("Primitive");
     indent ++;
  }

  public void identifierOption ()
  {
     super.identifierOption ();
     send ("identifier");
  }

  public void primitiveItem (String branch)
  {
     super.primitiveItem (branch);
     send ("item " + branch);
  }

  public void closePrimitive ()
  {
     super.closePrimitive ();
     indent --;
  }

  public void openBlock ()
  {
     super.openBlock ();
     send ("Block");
     indent ++;
  }

  public void closeBlock ()
  {
     super.closeBlock ();
     indent --;
     send ("End of block");
  }

  public void openAlternative ()
  {
     super.openAlternative ();
     send ("Alternative");
     indent ++;
  }


  public void closeAlternative ()
  {
     super.closeAlternative ();
     indent --;

     send ("End of alternative");
  }

  public void semanticPredicate (String name, boolean no_params)
  {
     super.semanticPredicate (name, no_params);
     send ("Semantic Predicate " + name);
  }

  public void openPredicate ()
  {
     super.openPredicate ();
     send ("Predicate");

     indent ++;
  }

  public void closePredicate ()
  {
     super.closePredicate ();
     indent --;
     send ("End of predicate");
  }

  public void terminal (String name)
  {
     super.terminal (name);
     send ("Terminal " + name);
  }

  public void nonterminal (int kind, String label, String name)
  {
     super.nonterminal (kind, label, name);

     String txt = name;

     if (kind == LABELED) txt = label + " : " + txt;
     if (kind == INSERT) txt = label + " <- " + txt;
     if (kind == ADD) txt = "<add> " + txt;
     if (kind == ASSIGN) txt = label + " = " + txt;
     if (kind == CALL) txt = "<call> " + txt;
     if (kind == RESULT) txt = "<result> " + txt;


     send ("Nonterminal " + txt);
  }

  public void setOption (String name, String value)
  {
     super.setOption (name, value);
     send ("Set " + name + " = " + value);
  }

  public void incOption (String name)
  {
     super.incOption (name);
     send ("Inc " + name);
  }

  public void silentOption ()
  {
     super.silentOption ();
     send ("Silent");
  }

  public void additionalOption (String name)
  {
     super.additionalOption (name);
     send ("Additional rule " + name);
  }

  public void invokeOption (String name)
  {
     super.invokeOption (name);
     send ("Invoke " + name);
  }

  public void executeOption (String name, boolean no_params)
  {
     super.executeOption (name, no_params);
     send ("Execute " + name);
  }

  public void redudantOption ()
  {
     super.redudantOption ();
     send ("Redudant");
  }

  public void locationOption (String name)
  {
     super.locationOption (name);
     send ("Location " + name);
  }

  public void styleOption (int style)
  {
     super.styleOption (style);

     String txt = "";
     switch (style)
     {
        case SPACE:               txt = "space";               break;
        case NO_SPACE:            txt = "no_space";            break;
        case NEW_LINE:            txt = "new_line";            break;
        case EMPTY_LINE:          txt = "empty_line";          break;
        case NO_EMPTY_LINE:       txt = "no_empty_line";       break;
        case INDENT:              txt = "indent";              break;
        case UNINDENT:            txt = "unindent";            break;
     }

     send ("Style " + txt);
  }

}
