
class TypeInfo extends DictItem
{

   public boolean used_as_field = false;

   public boolean is_pointer = false;

   public boolean hasSubclasses ()
   {
      return false;
   }

   public void addMethod (MethodInfo m)
   {
      err ("Structured type required: " + ident);
   }

   public boolean hasMethod (String id)
   {
     return false;
   }

  public StructInfo as_struct ()
   {
      if (! (this instanceof StructInfo))
         err ("Structured type required: " + ident);
      return (StructInfo) this;
   }

   public EnumInfo as_enum ()
   {
      if (! (this instanceof EnumInfo))
         err ("Enumerated type required: " + ident);
      return (EnumInfo) this;
   }

   public boolean is_derived_from (TypeInfo type)
   {
      return (this == type);
   }

   public String type_name ()
   {
     if (this instanceof StructInfo)
         return info.type_prefix + ident;
     else if (this instanceof EnumInfo)
         return info.type_prefix + ident;
     else
        return ident;
   }

   public String inner_decl ()
   {
     if (this instanceof StructInfo)
         return info.type_prefix + ident + " *";
     else if (this instanceof EnumInfo)
         return info.type_prefix + ident;
     else if (is_pointer)
        return ident + " *";
     else
        return ident;
   }

   public String decl ()
   {
     if (this instanceof StructInfo)
         return product_ns + info.type_prefix + ident + " *";
     if (this instanceof EnumInfo)
         return product_ns + info.type_prefix + ident;
     else
        return ident;
   }

}
